from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
import sys

from constants import *
from OpenGL.raw.GL import glPopMatrix

ESCAPE = '\033'

window = 0

estado = Correndo

nframes = 10.0

npos = 6

pos = 0

frame = 0

delay = 30

roty = 90
rotx = 0

distz = -15

def InitGL(Width, Height):                # We call this right after our OpenGL window is created.
    glClearColor(0.0, 0.0, 0.0, 0.0)    # This Will Clear The Background Color To Black
    glClearDepth(1.0)                    # Enables Clearing Of The Depth Buffer
    glDepthFunc(GL_LESS)                # The Type Of Depth Test To Do
    glEnable(GL_DEPTH_TEST)                # Enables Depth Testing
    glShadeModel(GL_SMOOTH)                # Enables Smooth Color Shading
    
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()                    # Reset The Projection Matrix
                                        # Calculate The Aspect Ratio Of The Window
    gluPerspective(45.0, float(Width)/float(Height), 0.1, 100.0)

    glMatrixMode(GL_MODELVIEW)

# The function called when our window is resized (which shouldn't happen if you enable fullscreen, below)
def ReSizeGLScene(Width, Height):
    if Height == 0:                        # Prevent A Divide By Zero If The Window Is Too Small 
        Height = 1

    glViewport(0, 0, Width, Height)        # Reset The Current Viewport And Perspective Transformation
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(60.0, float(Width)/float(Height), 0.5, 10000.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity();
#    glTranslatef(0.0, 0.0, distz);  


# The main drawing function.
def drawScene():
#    print('drawScene')
    defineLights()
    
    glPushMatrix()
    
    glTranslatef(0.0, 0.0, distz);
    
    glRotatef(roty,0,1,0)
    glRotatef(rotx,1,0,0)
    
    drawHorse()
    
    glPopMatrix()
    
    #  since this is double buffered, swap the buffers to display what just got drawn. 
    glutSwapBuffers()
    
     
def drawHorse():
    
    glPushMatrix()
    
    glColor3f(0.94,0.94,0.94)
    
    dang = posicoes[estado][pos+1][0] - posicoes[estado][pos][0]
    ang = posicoes[estado][pos][0] + float(dang)/nframes*frame
    glRotatef(ang,1,0,0)
    
#    tronco
    glPushMatrix()
    glTranslatef(0,0,-2)
    nquad = gluNewQuadric()
    gluCylinder(nquad, 1.0, 1.0, 4, 20, 20)
    glPopMatrix()
           
    glPushMatrix()
    glTranslatef(0,0,2)
    glScalef(TamOmbro,TamOmbro,TamOmbro)
    glutSolidSphere(1.0, 20, 20)
    glPopMatrix()
    
    glPushMatrix()
    glTranslatef(0,0,-2)
    glScalef(TamOmbro,TamOmbro,TamOmbro)
    glutSolidSphere(1.0, 20, 20)
    glPopMatrix()
    
    drawTail()
    
    #cabeca
    glPushMatrix()
    glTranslatef(0,0.6,2.5)
    
    
    dang = posicoes[estado][pos+1][1] - posicoes[estado][pos][1]
    ang = posicoes[estado][pos][1] + float(dang)/nframes*frame
    glRotatef(ang,1,0,0)
    
    #pescoco
    glPushMatrix()
    glScalef(0.7,0.7,0.7)
    nquad = gluNewQuadric()
    gluCylinder(nquad, 1.0, 0.7, 2.5, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,2)
    
    #queixo
    glPushMatrix()
    glScalef(0.65,0.65,0.65)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    drawEars()
    
    ang = posicoes[estado][pos][2]
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    glScalef(0.5,0.5,0.5)
    nquad = gluNewQuadric()    
    #gluCylinder( quad , base , top , height , slices , stacks )
    gluCylinder(nquad, 1, 0.65, 3.0, 20, 20)
    glTranslatef(0,0,3)
    glutSolidSphere(0.65,20,20)
    glPopMatrix()#/focinho
    
    glPopMatrix()#/cabeca
    
    drawFrontLeg(Direita,-0.6)#direita
    drawFrontLeg(Esquerda,0.6)#esquerda
    
    drawBackLeg(Direita,-0.6)
    drawBackLeg(Esquerda,0.6)
        
    glPopMatrix()
    
def drawTail():
    glPushMatrix()
    glTranslatef(0,0.4,-3)
    
    glPushMatrix()
    glScalef(0.2,0.2,0.2)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posicoes[estado][pos+1][3] - posicoes[estado][pos][3]
    ang = posicoes[estado][pos][3] + float(dang)/nframes*frame
    glRotatef(ang,1,0,0)
#    glTranslatef(0.3,0,0)
    
    glPushMatrix()
    glScalef(0.1,0.1,0.1)
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 1, 1, 4.0, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,0.4)
    
    glPushMatrix()
    glScalef(0.1,0.1,0.1)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posicoes[estado][pos+1][4] - posicoes[estado][pos][4]
    ang = posicoes[estado][pos][4] + float(dang)/nframes*frame
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.1, 0.2, 1.0, 20, 20)
    glTranslatef(0,0,1)
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.2, 0.1, 1.0, 20, 20)
    glPopMatrix()
    
    glPopMatrix()
    
def drawEars():
    glPushMatrix()
    glRotatef(-35,1,0,0)
    glTranslatef(0,0,0.4)
    
    glPushMatrix()
    glTranslatef(0.3,0,0)
    glScalef(0.2,0.2,0.2)
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 1, 0.3, 4.0, 20, 20)
    glPopMatrix()
    
    glPushMatrix()
    glTranslatef(-0.3,0,0)
    glScalef(0.2,0.2,0.2)
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 1, 0.3, 4.0, 20, 20)
    glPopMatrix()
    
    glPopMatrix()
    
def drawFrontLeg(lado,dx):
    glPushMatrix()
    
    glColor3f(0.94,0.94,0.94)
    
    glTranslatef(dx,-0.8,2.15)
    
    glPushMatrix()
    glScalef(0.45,0.45,0.45)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posPernaDiant[lado][estado][pos+1][0] - posPernaDiant[lado][estado][pos][0]
    ang = posPernaDiant[lado][estado][pos][0] + float(dang)/nframes*frame    
    
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.3, 0.2, TamCoxaDiant, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,1.8)
    
    glPushMatrix()
    glScalef(0.25,0.25,0.25)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posPernaDiant[lado][estado][pos+1][1] - posPernaDiant[lado][estado][pos][1]
    ang = posPernaDiant[lado][estado][pos][1] + float(dang)/nframes*frame  
    
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.15, 0.15, TamCanelaDiant, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,1.5)
    
    dang = posPernaDiant[lado][estado][pos+1][2] - posPernaDiant[lado][estado][pos][2]
    ang = posPernaDiant[lado][estado][pos][2] + float(dang)/nframes*frame  
    
    glRotate(ang,1,0,0)
    
    glColor3f(0.54,0.27,0.07)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.1, 0.3, 0.5, 20, 20)
    glPopMatrix()
    
    glPopMatrix()
    
def drawBackLeg(lado,dx):
    glPushMatrix()
    glTranslatef(dx,-0.4,-2.5)
    
    glColor3f(0.94,0.94,0.94)
    
    glPushMatrix()
    glScalef(0.5,0.5,0.5)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posPernaTras[lado][estado][pos+1][0] - posPernaTras[lado][estado][pos][0]
    ang = posPernaTras[lado][estado][pos][0] + float(dang)/nframes*frame
    
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.45, 0.45, 0.6, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,0.6)
    
    glPushMatrix()
    glScalef(0.45,0.45,0.45)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posPernaTras[lado][estado][pos+1][1] - posPernaTras[lado][estado][pos][1]
    ang = posPernaTras[lado][estado][pos][1] + float(dang)/nframes*frame
    
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.45, 0.2, TamCoxaTras, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,TamCoxaTras)
    
    glPushMatrix()
    glScalef(0.25,0.25,0.25)
    glutSolidSphere(1.0,20,20)
    glPopMatrix()
    
    dang = posPernaTras[lado][estado][pos+1][2] - posPernaTras[lado][estado][pos][2]
    ang = posPernaTras[lado][estado][pos][2] + float(dang)/nframes*frame
    
    glRotatef(ang,1,0,0)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.15, 0.15, TamCanelaTras, 20, 20)
    glPopMatrix()
    
    glTranslatef(0,0,TamCanelaTras-0.1)
    
    dang = posPernaTras[lado][estado][pos+1][3] - posPernaTras[lado][estado][pos][3]
    ang = posPernaTras[lado][estado][pos][3] + float(dang)/nframes*frame
    
    glRotate(ang,1,0,0)
    
    glColor3f(0.54,0.27,0.07)
    
    glPushMatrix()
    nquad = gluNewQuadric()    
    gluCylinder(nquad, 0.1, 0.3, 0.5, 20, 20)
    glPopMatrix()
    
    glPopMatrix()

def defineLights():
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    diffuseLight = [ 1.0, 1.0, 1.0, 1.0];
    ambientLight = [ 0.2, 0.2, 0.4, 1.0];
    lightPos = [ 0.0, 500.0, 100.0, 1.0 ];
    glEnable(GL_LIGHTING);
    glLightfv(GL_LIGHT0, GL_AMBIENT, ambientLight);
    glLightfv(GL_LIGHT0, GL_SPECULAR, diffuseLight);
    glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
    glEnable(GL_LIGHT0);
    glEnable(GL_COLOR_MATERIAL);
    glColor3f(1.0,1.0,1.0);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, diffuseLight );
    glMateriali(GL_FRONT_AND_BACK, GL_SHININESS, 50);

# The function called whenever a key is pressed. Note the use of Python tuples to pass in: (key, x, y)  
def keyPressed(*args):
    global pos, estado, delay, distz
    # If escape is pressed, kill everything.
    #print(args[0])
    if args[0] == ESCAPE:
        glutDestroyWindow(window)
        sys.exit()
        
    elif args[0] == 'm':
        if estado == Correndo:
            estado = Parado
        else:
            estado += 1
            
    elif args[0] == '.':
        if delay > 5:
            delay -= 5
    
    elif args[0] == ',':
        delay += 5
        
    elif args[0] == '=':
        distz += 1
        
    elif args[0] == '-':
        distz -= 1            
    
    '''
    elif args[0] == ' ':
        if pos == 5:
            pos = 0
        else:
            pos += 1
            
    '''
    glutPostRedisplay()
        
def specialKeyPressed(*args):
    global roty, rotx
    
    #print('special = '+str(args[0]))
    
    if args[0] == ESCAPE:
        glutDestroyWindow(window)
        sys.exit()        
    
    elif args[0] == GLUT_KEY_LEFT:
        roty = roty + 2
        glutPostRedisplay()

    elif args[0] == GLUT_KEY_RIGHT:
        roty = roty - 2
        glutPostRedisplay()
        
    elif args[0] == GLUT_KEY_UP:
        rotx = rotx + 2
        glutPostRedisplay()
        
    elif args[0] == GLUT_KEY_DOWN:
        rotx = rotx - 2
        glutPostRedisplay()
        
def update(value):
    global frame, pos
    if frame == nframes:
        frame = 1
        if pos >= npos-1:
            pos = 0
        else:
            pos += 1
    else:
        frame += 1
        
    glutPostRedisplay()
    glutTimerFunc(delay, update, 0)      
        
def main():
    global window

    glutInit(sys.argv)

    # Select type of Display mode:   
    #  Double buffer 
    #  RGBA color
    # Alpha components supported 
    # Depth buffer
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH)
    
    # get a 640 x 480 window 
    glutInitWindowSize(640, 480)
    
    # the window starts at the upper left corner of the screen 
    glutInitWindowPosition(200, 100)
    
    # Okay, like the C version we retain the window id to use when closing, but for those of you new
    # to Python (like myself), remember this assignment would make the variable local and not global
    # if it weren't for the global declaration at the start of main.
    window = glutCreateWindow("Horse")

    # Register the drawing function with glut, BUT in Python land, at least using PyOpenGL, we need to
    # set the function pointer and invoke a function to actually register the callback, otherwise it
    # would be very much like the C version of the code.    
    glutDisplayFunc(drawScene)
    #glutDisplayFunc()
    
    # Uncomment this line to get full screen.
    # glutFullScreen()

    # When we are doing nothing, redraw the scene.
#    glutIdleFunc(drawScene)
        
    # Register the function called when our window is resized.
    glutReshapeFunc(ReSizeGLScene)

    # Register the function called when the keyboard is pressed.  
    glutKeyboardFunc(keyPressed)
    
    # Register the function called when a special key is pressed.
    glutSpecialFunc(specialKeyPressed)
    
    # Initialize our window. 
    InitGL(640, 480)
    
    update(0)

    
# Print message to console, and kick off the main to get it rolling.
print "ESC para sair."
print "M para mudar o movimento."
print "Direcionais para mudar o angulo"
print ". para aumentar velocidade do movimento"
print ", para diminuir velocidade do movimento"
print "- para aumentar distancia no eixo z"
print "= para diminuir distancia no eixo z"

if __name__ == '__main__':
    try:
        GLU_VERSION_1_2
    except:
        print "Need GLU 1.2 to run this demo"
        sys.exit(1)
    main()
    glutMainLoop()
        
